#include <SM.h>

SM Gr7Secu(State10);//creation de la machine "Gr7Secu" et déclaration de State10
//comme l'état initial recevant le pion

SM TWOstates(State0);//creation de la machine "TWOstates" et déclaration de State0
//comme l'état initial recevant le pion
// le nom 2states n'est pas complié

//boutons poussoirs et contacts
#define DCY 11

#define KAU  26//PA0 PA1 PA2 PA3 PA4 PA5 PA6 PA7
//linked to    // A1 A0  A7  A6  A5  A4  A3  A2
//  pin        // 31 30  29  28  27  26  25  24
#define SENSORa1  28
#define SENSORa0  29

//electrovannes
#define Tsortie 7// T+ sur la patte PD7
#define LIGHTempty  27

int etat = 0;//variable utilisée pour la détection de front montants

void setup() {
  pinMode(Tsortie, OUTPUT);//PD7 en sortie
  pinMode(DCY, INPUT);// PD11 en entrée

  //to use pin 18, 19, 20, 21 correctly as digital outputs OR inputs and not with JTAG 
  uint8_t tmp = 1<<JTD; // Disable JTAG
  MCUCR = tmp; // Disable JTAG
  MCUCR = tmp; // Disable JTAG
  pinMode(18, OUTPUT);
  pinMode(19, OUTPUT);
  pinMode(20, OUTPUT);
  pinMode(21, INPUT);
  //A6 A5 A4 A3 can be used as digital output OR inputs with no ADMUX modification
  pinMode(LIGHTempty, OUTPUT);//A5
  pinMode(SENSORa0, INPUT);//A7
  pinMode(SENSORa1, INPUT);//A6
  pinMode(KAU, INPUT);//A4
}

void loop() {
 
  EXEC(Gr7Secu); //mise en marche de la state machine maitresse: Gr7Secu: un pion est mis dans State10
  //et les séquence peuvent se dérouler.

  if (digitalRead(KAU)==LOW) { //Stoppe la machine esclave 2states, (emergency stop)
    digitalWrite(Tsortie, LOW);//faire la remise à zéro des actions associés aux états
    TWOstates.Finish();
  }
  if (digitalRead(KAU)==HIGH && TWOstates.Finished) { //redémarre la machine esclave AvancePas
    EXEC(TWOstates);            //launch the Master machine
    TWOstates.Set(State0);     //un pion est mis dans l'état initiale State0 de l'esclave
    //quand on acquitte le défaut
  }

}


State State10() {
  digitalWrite(Tsortie, LOW);//T+ mis à 0
  if (digitalRead(KAU) == HIGH) Gr7Secu.Set(State11);//transition de State10 vers State11
}

State State11() {
  EXEC(TWOstates);
  if (digitalRead(KAU) == LOW) Gr7Secu.Set(State10);//transition de State10 vers State11 
  //si appui sur ATU
}

State State0() {
  digitalWrite(Tsortie, LOW);//T+ mis à 0
  if (RE(digitalRead(DCY), etat) == 1) TWOstates.Set(State1);
  //transition de State0 vers State1
}

State State1() {
  digitalWrite(Tsortie, HIGH);//T+ mis à 1
  if (RE(digitalRead(DCY), etat) == 1) TWOstates.Set(State0); //transition de State1 vers State2
}














